<!DOCTYPE html>
<html lang="it">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Previsione Raccolto</title>

    <!-- Includi prima jQuery -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

    <!-- Includi Bootstrap CSS -->
    <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">

    <!-- Includi Bootstrap JS dopo jQuery -->
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <style>
        body {
            background-color: #f8f9fa;
        }

        .container {
            margin-top: 50px;
            max-width: 600px;
            background-color: #fff;
            padding: 30px;
            box-shadow: 0px 0px 15px rgba(0, 0, 0, 0.1);
            border-radius: 8px;
        }

        .form-group {
            margin-bottom: 1.5rem;
        }

        h2 {
            margin-bottom: 20px;
            font-size: 24px;
            text-align: center;
        }

        .btn {
            width: 100%;
        }

        #italy-map {
            position: relative;
            width: 100%;
            height: auto;
        }

        .region {
            position: absolute;
            fill-opacity: 0.5;
            stroke: #000;
            stroke-width: 1;
        }

        .alta {
            fill: red;
        }

        .media {
            fill: yellow;
        }

        .bassa {
            fill: green;
        }
    </style>
</head>

<body>
    <div class="container">
        <h2>Previsione Raccolto di Frumento</h2>
        <div id="disclaimer" class="mt-4 p-3 bg-danger text-white rounded">
            <p class="mb-0">
                <strong>Disclaimer</strong> <br>
                Le previsioni fornite da questa applicazione sono generate da un modello di machine learning. <br>
                I risultati sono basati sui dati disponibili e possono essere soggetti a errori. <br>
                <strong>Si raccomanda di considerare le previsioni come indicative e non definitive.</strong><br>
                Il modello è stato addestrato con un dataset contenente dati geografici, meteorologici e coltivativi
                <strong>italiani</strong>. <br>
                Per l'addestramento è stato utilizzato il regressore Random Forest Regressor e per la validazione il
                K-Fold
                Cross Validator. <br>
                Il dataset è composto da 6670 record e per la cross validation sono stati utilizzati 20 fold (quindi
                circa 330
                record per fold).
            </p>
        </div>
        <br>
        <form id="prediction-form">
            <!-- Campi del form -->
            <div class="form-group">
                <label for="alt">Altitudine (in metri)</label>
                <input type="number" class="form-control" id="alt" name="alt" placeholder="Es. 300" required>
            </div>

            <div class="form-group">
                <label for="lat">Latitudine (in gradi)</label>
                <input type="number" class="form-control" id="lat" name="lat" step="any" placeholder="Es. 45.4642"
                    required>
            </div>

            <div class="form-group">
                <label for="lon">Longitudine (in gradi)</label>
                <input type="number" class="form-control" id="lon" name="lon" step="any" placeholder="Es. 9.1900"
                    required>
            </div>

            <div class="form-group">
                <label for="superficie_media">Superficie (in ettari)</label>
                <input type="number" class="form-control" id="superficie_media" name="superficie_media" step="any"
                    placeholder="Es. 50" required>
            </div>

            <div class="form-group">
                <label for="prec_media">Precipitazioni medie annue (in mm)</label>
                <input type="number" class="form-control" id="prec_media" name="prec_media" step="any"
                    placeholder="Es. 900" required>
            </div>

            <div class="form-group">
                <label for="temp_media">Temperatura media annua (in °C)</label>
                <input type="number" class="form-control" id="temp_media" name="temp_media" step="any"
                    placeholder="Es. 15" required>
            </div>

            <!-- Seleziona il modello di previsione -->
            <div class="form-group">
                <div id="metrics-display" style="margin-top: 15px;">
                    <p><strong>Metriche del modello Random Forest:</strong></p>
                    <p>Root Mean Squared Error (RMSE): <span id="rmse-value">1327.75</span></p>
                    <p>R-squared (R²): <span id="r2-value">0.99</span></p>
                    <p>Mean Squared Error (MSE): <span id="mse-value">7518370.30</span></p>
                    <p>Mean Absolute Error (MAE): <span id="mae-value">102.22</span></p>
                    <p>Mean Absolute Percentage Error (MAPE): <span id="mape-value">0.032</span></p>
                </div>
            </div>

            <button type="submit" class="btn btn-primary">Ricevi previsione</button>
        </form>

        <div id="prediction-result" class="mt-4"></div>

        <button id="buttonProva" class="btn btn-primary">Visualizza mappa</button>
        <hr>
        <div style="text-align:center;"><canvas id="productionMap" width="310" height="500" style="text-align:center;"></canvas>    </div>
    </div>




    <script>


        var valuesForMap = $(this).serialize();
        $(document).ready(function () {
            $('#buttonProva').click(function (event) {
                event.preventDefault();

                $.ajax({
                    type: 'POST',
                    url: '/returnValueForMap',
                    data: valuesForMap,
                    success: function (response) {
                        valuesForMap = response


                        let arrayDiviso = valuesForMap.split("#");
                        let arrayFinale = arrayDiviso.map(substringa => substringa.split(","));
                        Lat = arrayFinale[0]
                        Lon = arrayFinale[1]
                        Prod = arrayFinale[2]

                        var minLat = Math.min(...Lat.slice(0, -1))
                        var maxLat = Math.max(...Lat)
                        var minLon = Math.min(...Lon.slice(0, -1))
                        var maxLon = Math.max(...Lon)
                        var minProd = Math.min(...Prod.slice(0, -1))
                        var maxProd = Math.max(...Prod)

                        var c = document.getElementById("productionMap");
                        var ctx = c.getContext("2d");
                        var canvasWidth = c.width;
                        var canvasHeight = c.height - 50;
                        
                        drawLegend(ctx,canvasWidth,canvasHeight,minProd, maxProd)


                        for (let i = 0; i < Prod.length; i++) {
                            ctx.fillStyle = getColorMap((Prod[i]-minProd)/(maxProd-minProd))
                            let y = (1 - (Lat[i]-minLat)/(maxLat-minLat)) * canvasHeight
                            let x = (Lon[i]-minLon)/(maxLon-minLon) * canvasWidth
                            ctx.fillRect(x-1,y-1,3,3);    
                        }

                    },
                    error: function (error) {
                        console.error(error);
                    }
                });
            });
        });

    
        function drawLegend(ctx, width, height, minProd, maxProd){
            ctx.fillStyle = '#000000'
            ctx.font = "15px Arial";
            ctx.fillText("Produzione in quintali annua:",0,height+15);
            for (let i = 0; i < width; i++) { 
                ctx.fillStyle = getColorMap(i/width)
                ctx.fillRect(i,height + 25,5,5); 
            }
            //produzione in quintali:
            ctx.fillStyle = '#000000'
            ctx.font = "15px Arial";
            ctx.fillText("Minore",0,height + 45);
            ctx.fillText("Maggiore",width*0.8,height + 45);
        }

        function getColorMap(percentage) {
            if (percentage <= 0.5) {
                return '#' + "ff" + normalizeValueForColor(0xff * percentage * 2) + "00";        // nel caso aggiungere trasparenza 88 o 44
            } else {
                return '#' + normalizeValueForColor(0xff - 0xff * (percentage - 0.5) * 2) + "ff" + "00";
            }
        }

        function normalizeValueForColor(value) {
            Nvalue = (Math.trunc(value)).toString(16)
            if (Nvalue.length == 1)
                return '0' + Nvalue;
            return Nvalue
        }
    </script>



    <script>

        $(document).ready(function () {
            $('#prediction-form').submit(function (event) {
                event.preventDefault();
                var formData = $(this).serialize();

                $.ajax({
                    type: 'POST',
                    url: '/predict',
                    data: formData,
                    success: function (response) {
                        $('#prediction-result').html('<div class="alert alert-success">' + response + '</div>');
                    },
                    error: function (error) {
                        $('#prediction-result').html('<div class="alert alert-danger">Errore durante la previsione. Riprova più tardi.</div>');
                    }
                });
            });
        });
    </script>
</body>

</html>